<h1> ROM for steady laminar fluid flows. </h1>

<h2> Overview </h2>

This tutorial is designed to introduce to the user the fundamental steps one has to take to generate a POD-RB ROM
using GeN-ROM:
* **Generating snapshots:** Using a predefined desing, we solve a higher
  fidelity model at different model parameter values
  and save certain fields to create
  global basis functions for the ROM generation.
* **Generating reduced operators:** We use the snapshots to extract the global basis functions and to reduce the
  dimensionality of the operators of the higher fidelity model. We then save the basis
  functions and reduced operators for further use.
  With this, the ROM is ready to use.
* **Testing the ROM:**
  In this step, we solve the higher fidelity model and the ROM together at multiple new parameter combinations.
  Then, we take results of the ROM and compare them to those of the FOM. We usually comapre based on the
  mean/maximum relative L<sup>2 </sup> errors over the test set.

These steps are all carried out is the user navigates into the given tutorial folder and executes the
*Allrun* script:
```
cd tutorials/steady-laminar-fluid
./Allrun
```
This involves two uncertain parameters in a closed MSR loop: the dynamic viscosity and the pumping power.
For more details on the model see the references on the [main page](../../../README.md).
Altogether 10 snapshots are generated together with 5 more solves to produce samples for
testing the ROM. The higher fidelity model is executed using 4 threads by default, while the
ROM solves are executed in serial.
If an error is encountered one may want to clean up the directory before trying to rerun the case using:
```
./Allclean
```
The following subsections discuss the different steps in detail.

<h2> Creating snapshots </h2>

To generate snapshots, we utilize a *python* script which can modify OpenFOAM/GeN-Foam
input files and collect results. This script is reused for most of the steps in this process.
First we create a copy of the rootCase as:
```
cd tutorials/steady-laminar-fluid
cp -r rootCase snapshot_generation
cd snapshot_generation
```
Then we generate **10 snapshots** with an **LHS** sampling and save them in the **ROMFiles/snapshots** subdirectory
by executing the script as follows:
```
python ../../../python/snapshotGenerationv2/snapGeN.py -i snapGenInput -s LHS -ns 10 -d ROMFiles/snapshots -c "./run.sh"
```
In this case the *-c* argument is the command the script uses to execute the case.
*run.sh* is shell script which executes the case in parallel using 4 threads.
The model parameters which are used in this case (dynamic viscosity and pumping power)
are defined in the *snapGenInput* input file (also uses python syntax) together with
the solution fields the script should collect. Furthermore, we see that the *-s*
argument has been used to select the sampling for the model parameters. In this scenario
we used LHS.
For further information on the behavior of the script, we refer the reader to:
```
python ../../../python/snapshotGenerationv2/snapGeN.py -h
```

<h2> Generating reduced operators </h2>

Once the snapshots are at our discposal, we can create the global basis functions.
For this, we create a copy of the previous work directory:
```
cp -r snapshot_generation rom_generation
cd rom_generation
```
At this point the user needs to take a look at the *system/ROMDict* dictionary file which
contains the control parameters for the ROM. To make sure that the basis functions and the operators are
created one has to set the following two parameters:
```
readOperators false;
readBases false;
```
One can also select the number of basis functions per physics and the type of solvers to use for the ROM.
To ensure that the ROM is not solved, one can increase *deltaT* in *system/controlDict* to 100.
Once these conditions are met, we generate the ROM by simply executing:
```
GeN-ROM
```

<h2> Creating test samples </h2>

Now we turn our attention to testing the ROM. First, we need the reference samples
from the higher fidelity model. This can be done by copying the previously created
case directory into a new one:
```
cp -r rom_generation fom_test
cd fom_test
```
Then, exactly like in case of the snapshot generation we use the python script to create **5** test samples
and save them into the **ROMFiles/testFOM** directory:
```
python ../../../python/snapshotGenerationv2/snapGeN.py -i snapGenInput -s LHS -ns 5 -d ROMFiles/testFOM -c "./run.sh"
```

<h2> Testing the ROM </h2>

Finally, the last step of the process involves testing the ROM.
Luckily we can use the same python script to execute GeN-ROM. We start with the usual process:
```
cp -r fom_test rom_test
cd rom_test
```
Then, one needs to change the read parameters in *system/ROMDict* to ensure that
the reduced bases and operators are not generated every time GeN-ROM is executed:
```
readOperators true;
readBases true;
```
Once this is done, the user shall set the *deltaT* parameter in *system/controlDict*
to 40, to ensure that the ROM is executed only once (considering it is a steady-state problem).
Following this, we can simply use the python script to collect the ROM results
into the **ROMFiles/testROM** directory:
```
python ../../../python/snapshotGenerationv2/snapGeN.py -i snapGenInputROM -s LHS -ns 5 -d ROMFiles/testROM -c GeN-ROM
```
Note that a different input file has been used for the script that ensures that the
ROM files are collected in this scenario.

Lastly, to compare the resulkts from the FOM and the ROM in na L<sup>2</sup> sense, we need the
cell volumes. Luckily, OpenFOAM can be used to generate these as:
```
cd ROMFiles/testFOM
ln -s ../../system .
ln -s ../../constant .
postProcess -func writeCellVolumes -region fluidRegion
cd ../..
```

Using these we can call another python script to generate the statistics of the relative L<sup>2</sup> sense error:
```
python ../../../python/TestingROM/TestROM.py
```
This requires a *testROMInput.py* file in the directory which has been already set up for this tutorial.
One can modify this file to choose which fields need to be compared and where they are located.
If everything is executed correctly and if the user choses to keep
the number of modes in the predefined *ROMDict*, one should be able to observe the following results:
```
-------------------------------------------------------------------------------
 Reading controls from testROMInput.
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
 Comparing the fields in the given directories.
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
 Printing statistics.
-------------------------------------------------------------------------------
UDarcy mean error: 0.0008343847763753644, max error: 0.0012138794329865658
p_rgh mean error: 0.0010324480278438158, max error: 0.00131131762270946
```
Lastly, the script outputs the relative L<sup>2</sup> differences in
.txt files for every single sample with the following notation:
```
<field_name>Error.txt
```
